#!/usr/bin/env nqp
# Copyright (C) 2014, The Perl Foundation


sub MAIN(*@ARGS) {
    my $program := @ARGS.shift;
    my $backend := @ARGS.shift;
    say("# This file automatically generated by $program\n");
    for @ARGS -> $file {
        say("# From $file\n");
        my $fh := open($file, :r);
        my $in_cond := 0;
        my $in_omit := 0;
        while nqp::readlinefh($fh) -> $_ {
            if my $x := $_ ~~ / ^ '#?if' \s+ ('!')? \s* (\w+) \s* $ / {
                nqp::die("Nested conditionals not supported") if $in_cond;
                $in_cond := 1;
                $in_omit := $x[0] && $x[1] eq $backend || !$x[0] && $x[1] ne $backend;
            } elsif $_ ~~ /^ '#?endif' / {
                $in_cond := 0;
                $in_omit := 0;
            } elsif  !$in_omit {
                print($_) unless $_ ~~ /^ '# ' \w /;
            }
        }
        close($fh);
    }
    say("\n# vim: set ft=perl6 nomodifiable :");
}


# vim: set ft=perl6 :
